## net.sf.saxon.om
Class StrippedNode

    java.lang.Object
      net.sf.saxon.om.StrippedNode

All Implemented Interfaces:
  Item, NodeInfo, javax.xml.transform.Source, ValueRepresentation, VirtualNode

Direct Known Subclasses:
  StrippedDocument

public class StrippedNode
extends java.lang.Object
implements NodeInfo, VirtualNode

A StrippedNode is a view of a node, in a virtual tree that has whitespace text nodes stripped from it. All operations on the node produce the same result as operations on the real underlying node, except that iterations over the axes take care to skip whitespace-only text nodes that are supposed to be stripped. Note that this class is only used in cases where a pre-built tree is supplied as the input to a transformation, and where the stylesheet does whitespace stripping; if a SAXSource or StreamSource is supplied, whitespace is stripped as the tree is built.

Field Summary
`protected StrippedDocument` `docWrapper`
`protected NodeInfo` `node`
`protected StrippedNode` `parent`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, LOCAL_NAMESPACES, NO_NAMESPACES`

Constructor Summary
`protected` `StrippedNode()`
`protected` `StrippedNode(NodeInfo node, StrippedNode parent)` This constructor is protected: nodes should be created using the makeWrapper factory method

Method Summary
`int` `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
`void` `copy(Receiver out, int whichNamespaces, boolean copyAnnotations, int locationId)` Copy this node to a given outputter (deep copy)
`java.lang.String` `generateId()` Get a character string that uniquely identifies this node.
`java.lang.String` `getAttributeValue(int fingerprint)` Get the value of a given attribute of this node
`java.lang.String` `getBaseURI()` Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
`Configuration` `getConfiguration()` Get the configuration
`int[]` `getDeclaredNamespaces(int[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
`java.lang.String` `getDisplayName()` Get the display name of this node.
`int` `getDocumentNumber()` Get the document number of the document containing this node.
`DocumentInfo` `getDocumentRoot()` Get the root (document) node
`int` `getFingerprint()` Get fingerprint.
`int` `getLineNumber()` Get line number
`java.lang.String` `getLocalPart()` Get the local part of the name of this node.
`int` `getNameCode()` Get name code.
`NamePool` `getNamePool()` Get the name pool for this node
`int` `getNodeKind()` Return the type of node.
`NodeInfo` `getParent()` Get the NodeInfo object representing the parent of this node
`java.lang.String` `getPrefix()` Get the prefix of the name of the node.
`NodeInfo` `getRoot()` Get the root node - always a document node with this tree implementation
`java.lang.String` `getStringValue()` Return the string value of the node.
`java.lang.CharSequence` `getStringValueCS()` Get the value of the item as a CharSequence.
`java.lang.String` `getSystemId()` Get the System ID for the node.
`int` `getTypeAnnotation()` Get the type annotation
`SequenceIterator` `getTypedValue()` Get the typed value of the item
`java.lang.Object` `getUnderlyingNode()` Get the underlying DOM node, to implement the VirtualNode interface
`java.lang.String` `getURI()` Get the URI part of the name of this node.
`boolean` `hasChildNodes()` Determine whether the node has any children.
`boolean` `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node.
`AxisIterator` `iterateAxis(byte axisNumber)` Return an iteration over the nodes reached by the given axis from this node
`AxisIterator` `iterateAxis(byte axisNumber, NodeTest nodeTest)` Return an iteration over the nodes reached by the given axis from this node
`protected StrippedNode` `makeWrapper(NodeInfo node, StrippedDocument docWrapper, StrippedNode parent)` Factory method to wrap a node with a wrapper that implements the Saxon NodeInfo interface.
`void` `sendNamespaceDeclarations(Receiver out, boolean includeAncestors)` Output all namespace nodes associated with this element.
`void` `setSystemId(java.lang.String uri)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### node

    protected NodeInfo node

### parent

    protected StrippedNode parent

### docWrapper

    protected StrippedDocument docWrapper

Constructor Detail

### StrippedNode

    protected StrippedNode()

### StrippedNode

    protected StrippedNode(NodeInfo node,
                           StrippedNode parent)

  This constructor is protected: nodes should be created using the makeWrapper factory method

Parameters:
  `node` - The node to be wrapped
  `parent` - The StrippedNode that wraps the parent of this node

Method Detail

### makeWrapper

    protected StrippedNode makeWrapper(NodeInfo node,
                                       StrippedDocument docWrapper,
                                       StrippedNode parent)

  Factory method to wrap a node with a wrapper that implements the Saxon NodeInfo interface.

  Parameters:
    `node` - The underlying node
    `docWrapper` - The wrapper for the document node (must be supplied)
    `parent` - The wrapper for the parent of the node (null if unknown)
  Returns:
    The new wrapper for the supplied node

### getUnderlyingNode

    public java.lang.Object getUnderlyingNode()

  Get the underlying DOM node, to implement the VirtualNode interface

  Specified by:
    `getUnderlyingNode` in interface `VirtualNode`
  Returns:
    The underlying node. Note that this may itself be a VirtualNode; you may have to drill down through several layers of wrapping.

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration

  Specified by:
    `getConfiguration` in interface `NodeInfo`

### getNamePool

    public NamePool getNamePool()

  Get the name pool for this node

  Specified by:
    `getNamePool` in interface `NodeInfo`
  Returns:
    the NamePool

### getNodeKind

    public int getNodeKind()

  Return the type of node.

  Specified by:
    `getNodeKind` in interface `NodeInfo`
  Returns:
    one of the values Node.ELEMENT, Node.TEXT, Node.ATTRIBUTE, etc.
  See Also:
    `Type`

### getTypedValue

    public SequenceIterator getTypedValue()
                                   throws XPathException

  Get the typed value of the item

  Specified by:
    `getTypedValue` in interface `Item`
  Returns:
    the typed value of the item. In general this will be a sequence
  Throws:
    `XPathException` - where no typed value is available, e.g. for an element with complex content

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation

  Specified by:
    `getTypeAnnotation` in interface `NodeInfo`
  Returns:
    0 (there is no type annotation)
  See Also:
    `Type`

### isSameNodeInfo

    public boolean isSameNodeInfo(NodeInfo other)

  Determine whether this is the same node as another node.
  Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)

  Specified by:
    `isSameNodeInfo` in interface `NodeInfo`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this Node object and the supplied Node object represent the same node in the tree.

### getSystemId

    public java.lang.String getSystemId()

  Get the System ID for the node.

  Specified by:
    `getSystemId` in interface `NodeInfo`
  Returns:
    the System Identifier of the entity in the source document containing the node, or null if not known. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot.

### setSystemId

    public void setSystemId(java.lang.String uri)

  Specified by:
    `setSystemId` in interface `javax.xml.transform.Source`

### getBaseURI

    public java.lang.String getBaseURI()

  Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node. In the JDOM model, base URIs are held only an the document level. We don't currently take any account of xml:base attributes.

  Specified by:
    `getBaseURI` in interface `NodeInfo`
  Returns:
    the base URI of the node

### getLineNumber

    public int getLineNumber()

  Get line number

  Specified by:
    `getLineNumber` in interface `NodeInfo`
  Returns:
    the line number of the node in its original source document; or -1 if not available

### compareOrder

    public int compareOrder(NodeInfo other)

  Determine the relative position of this node and another node, in document order. The other node will always be in the same document.

  Specified by:
    `compareOrder` in interface `NodeInfo`
  Parameters:
    `other` - The other node, whose position is to be compared with this node
  Returns:
    -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

### getStringValue

    public java.lang.String getStringValue()

  Return the string value of the node. The interpretation of this depends on the type of node. For an element it is the accumulated character content of the element, including descendant elements.

  Specified by:
    `getStringValue` in interface `NodeInfo`
  Returns:
    the string value of the node

### getStringValueCS

    public java.lang.CharSequence getStringValueCS()

  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item`

### getNameCode

    public int getNameCode()

  Get name code. The name code is a coded form of the node name: two nodes with the same name code have the same namespace URI, the same local name, and the same prefix. By masking the name code with &0xfffff, you get a fingerprint: two nodes with the same fingerprint have the same local name and namespace URI.

  Specified by:
    `getNameCode` in interface `NodeInfo`
  Returns:
    an integer name code, which may be used to obtain the actual node name from the name pool
  See Also:
    `allocate`

### getFingerprint

    public int getFingerprint()

  Get fingerprint. The fingerprint is a coded form of the expanded name of the node: two nodes with the same name code have the same namespace URI and the same local name. A fingerprint of -1 should be returned for a node with no name.

  Specified by:
    `getFingerprint` in interface `NodeInfo`
  Returns:
    an integer fingerprint; two nodes with the same fingerprint have the same expanded QName

### getLocalPart

    public java.lang.String getLocalPart()

  Get the local part of the name of this node. This is the name after the ":" if any.

  Specified by:
    `getLocalPart` in interface `NodeInfo`
  Returns:
    the local part of the name. For an unnamed node, returns null, except for un unnamed namespace node, which returns "".

### getURI

    public java.lang.String getURI()

  Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.

  Specified by:
    `getURI` in interface `NodeInfo`
  Returns:
    The URI of the namespace of this node. For an unnamed node, return null. For a node with an empty prefix, return an empty string.

### getPrefix

    public java.lang.String getPrefix()

  Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, return a zero-length string.

  Specified by:
    `getPrefix` in interface `NodeInfo`
  Returns:
    The prefix of the name of the node.

### getDisplayName

    public java.lang.String getDisplayName()

  Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.

  Specified by:
    `getDisplayName` in interface `NodeInfo`
  Returns:
    The display name of this node. For a node with no name, return an empty string.

### getParent

    public NodeInfo getParent()

  Get the NodeInfo object representing the parent of this node

  Specified by:
    `getParent` in interface `NodeInfo`
  Returns:
    the parent of this node; null if this node has no parent

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber)

  Return an iteration over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - the axis to be used
  Returns:
    a SequenceIterator that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber,
                                    NodeTest nodeTest)

  Return an iteration over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - the axis to be used
    `nodeTest` - A pattern to be matched by the returned nodes
  Returns:
    a SequenceIterator that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### getAttributeValue

    public java.lang.String getAttributeValue(int fingerprint)

  Get the value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists or null if not

### getRoot

    public NodeInfo getRoot()

  Get the root node - always a document node with this tree implementation

  Specified by:
    `getRoot` in interface `NodeInfo`
  Returns:
    the NodeInfo representing the containing document

### getDocumentRoot

    public DocumentInfo getDocumentRoot()

  Get the root (document) node

  Specified by:
    `getDocumentRoot` in interface `NodeInfo`
  Returns:
    the DocumentInfo representing the containing document

### hasChildNodes

    public boolean hasChildNodes()

  Determine whether the node has any children.
  Note: the result is equivalent to
  getEnumeration(Axis.CHILD, AnyNodeTest.getInstance()).hasNext()

  Specified by:
    `hasChildNodes` in interface `NodeInfo`
  Returns:
    True if the node has one or more children

### generateId

    public java.lang.String generateId()

  Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)

  Specified by:
    `generateId` in interface `NodeInfo`
  Returns:
    a string that uniquely identifies this node, within this document. The calling code prepends information to make the result unique across all documents.

### getDocumentNumber

    public int getDocumentNumber()

  Get the document number of the document containing this node. For a free-standing orphan node, just return the hashcode.

  Specified by:
    `getDocumentNumber` in interface `NodeInfo`

### copy

    public void copy(Receiver out,
                     int whichNamespaces,
                     boolean copyAnnotations,
                     int locationId)
              throws XPathException

  Copy this node to a given outputter (deep copy)

  Specified by:
    `copy` in interface `NodeInfo`
  Parameters:
    `out` - the Receiver to which the node should be copied
    `whichNamespaces` - in the case of an element, controls which namespace nodes should be copied. Values are `NodeInfo.NO_NAMESPACES`, `NodeInfo.LOCAL_NAMESPACES`, `NodeInfo.ALL_NAMESPACES`
    `copyAnnotations` - indicates whether the type annotations of element and attribute nodes should be copied
    `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information for the original node is to be copied; in this case the Receiver must be a LocationCopier
  Throws:
    `XPathException`

### sendNamespaceDeclarations

    public void sendNamespaceDeclarations(Receiver out,
                                          boolean includeAncestors)
                                   throws XPathException

  Output all namespace nodes associated with this element. Does nothing if the node is not an element.

  Specified by:
    `sendNamespaceDeclarations` in interface `NodeInfo`
  Parameters:
    `out` - The relevant outputter
    `includeAncestors` - True if namespaces declared on ancestor elements must
  Throws:
    `XPathException`

### getDeclaredNamespaces

    public int[] getDeclaredNamespaces(int[] buffer)

  Get all namespace undeclarations and undeclarations defined on this element.

  Specified by:
    `getDeclaredNamespaces` in interface `NodeInfo`
  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.